/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1beta2

import (
	"context"
	"time"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	scheme "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-aws/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AWSClusterTemplatesGetter has a method to return a AWSClusterTemplateInterface.
// A group's client should implement this interface.
type AWSClusterTemplatesGetter interface {
	AWSClusterTemplates(namespace string) AWSClusterTemplateInterface
}

// AWSClusterTemplateInterface has methods to work with AWSClusterTemplate resources.
type AWSClusterTemplateInterface interface {
	Create(ctx context.Context, aWSClusterTemplate *v1beta2.AWSClusterTemplate, opts v1.CreateOptions) (*v1beta2.AWSClusterTemplate, error)
	Update(ctx context.Context, aWSClusterTemplate *v1beta2.AWSClusterTemplate, opts v1.UpdateOptions) (*v1beta2.AWSClusterTemplate, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta2.AWSClusterTemplate, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta2.AWSClusterTemplateList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterTemplate, err error)
	AWSClusterTemplateExpansion
}

// aWSClusterTemplates implements AWSClusterTemplateInterface
type aWSClusterTemplates struct {
	client rest.Interface
	ns     string
}

// newAWSClusterTemplates returns a AWSClusterTemplates
func newAWSClusterTemplates(c *InfrastructureV1beta2Client, namespace string) *aWSClusterTemplates {
	return &aWSClusterTemplates{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the aWSClusterTemplate, and returns the corresponding aWSClusterTemplate object, and an error if there is any.
func (c *aWSClusterTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSClusterTemplate, err error) {
	result = &v1beta2.AWSClusterTemplate{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("awsclustertemplates").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AWSClusterTemplates that match those selectors.
func (c *aWSClusterTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSClusterTemplateList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta2.AWSClusterTemplateList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("awsclustertemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested aWSClusterTemplates.
func (c *aWSClusterTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("awsclustertemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a aWSClusterTemplate and creates it.  Returns the server's representation of the aWSClusterTemplate, and an error, if there is any.
func (c *aWSClusterTemplates) Create(ctx context.Context, aWSClusterTemplate *v1beta2.AWSClusterTemplate, opts v1.CreateOptions) (result *v1beta2.AWSClusterTemplate, err error) {
	result = &v1beta2.AWSClusterTemplate{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("awsclustertemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSClusterTemplate).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a aWSClusterTemplate and updates it. Returns the server's representation of the aWSClusterTemplate, and an error, if there is any.
func (c *aWSClusterTemplates) Update(ctx context.Context, aWSClusterTemplate *v1beta2.AWSClusterTemplate, opts v1.UpdateOptions) (result *v1beta2.AWSClusterTemplate, err error) {
	result = &v1beta2.AWSClusterTemplate{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("awsclustertemplates").
		Name(aWSClusterTemplate.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(aWSClusterTemplate).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the aWSClusterTemplate and deletes it. Returns an error if one occurs.
func (c *aWSClusterTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("awsclustertemplates").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *aWSClusterTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("awsclustertemplates").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched aWSClusterTemplate.
func (c *aWSClusterTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterTemplate, err error) {
	result = &v1beta2.AWSClusterTemplate{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("awsclustertemplates").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
